------------------------------------------------------------------------------
--                          MENU ENGINE                                     --
------------------------------------------------------------------------------
--Author:    Daniel Berstein Zimmermann
--Date:      13 of Octubre 1996, Santiago de Chile
--E-mail:    dberst@cmet.net
-----------------------------------------------------------------------------
-- Function dia_hora() was created by Ral Campos ;-)
----------------
--FUNCTION MENU--
----------------
--Sintax:
-- menu( sequence "items", sequence "options", sequence "colors" )
----------------
--Parameters:
-- "items"   --> sequence containing the menu items
-- "options" --> sequence with the following menu specifications:
--              options[1] = upper row coordinate
--              options[2] = left column coordinate
--              options[3] = maximum column length
--              options[4] = columns width
--              options[5] = number of visible columns
--              options[6] = light-bar style (0=minimum, 1=complete)
--              options[7] = scroll-bar (0=no, 1=yes)
-- "colors" --> sequence with menu colors:
--              colors[1] = normal foreground
--              colors[2] = normal background
--              colors[3] = highlighted foreground
--              colors[4] = highlighted backgorund
----------------
----------------
--Returns:
-- Position within "items" of the selected option.
-- Returns -1 if the selection is canceled.
----------------
--Notes:
-- a) The scrollbar may not work fine if the column length (options[3]) is
--  less than 3.
----------------
--Future release:
-- Mouse support
----------------

include graphics.e
include file.e
include get.e
          constant DIAS = {
                           "Sunday","Monday",
                           "Tuesday","Wednesday",
                           "Thursday","Friday",
                           "Saturday"
                          },
                   MESES = {
                             "January","February","March",
                             "April","May","June",
                             "July","August","September",
                             "October","November","December"
                            }
global sequence t
procedure reloj( integer y_r, integer x_r, sequence color )
   bk_color(color[1])
   t = date()
   text_color(color[2])
   position(y_r,x_r)
   if t[4] < 10 then
      puts(1,"0")
   end if
   print(1,t[4])
   text_color(color[2]+16)
   puts(1,":")
   text_color(color[2])
   if t[5] < 10 then
      puts(1,"0")
   end if 
      print(1,t[5])
   text_color(color[2]+16)
end procedure
procedure fecha(integer y_f, integer x_f, sequence color_f )
bk_color(color_f[1])
   text_color(color_f[2])
   t = date()
   position(y_f,x_f)
   puts(1,DIAS[t[7]]&" ")
   print(1,t[3])
   puts(1,", ")
   puts(1,MESES[t[2]]&" ")
   if t[1] > 99 or t[1] = 0 then
      puts(1,"20")
   else  
      puts(1,"19")
   end if
   print(1,t[1])
end procedure    
     
procedure dia_hora( sequence relo_par, sequence fech_par)
    fecha(fech_par[1][1], fech_par[1][2],{fech_par[2][1], fech_par[2][2]})
    reloj(relo_par[1][1], relo_par[1][2],{relo_par[2][1], relo_par[2][2]})
end procedure

global function menu(sequence items, sequence options, sequence colors, 
                     integer clock, sequence clock_options,
                     sequence Date_options) -- clock = 1 with clock & date

    -- Declare variables
    integer number_of_columns, first_column, last_column
    integer current_row, current_column, reimprimir
    sequence video
    object aux1, aux2

    video = video_config()
    cursor(NO_CURSOR)

    -- Check no item is wider than options[4]
    for loop = 1 to length(items) do
        if  options[4] < length(items[loop])then
            options[4] = length(items[loop])
        end if
    end for

    -- Check if number of visible columns is OK
    if options[2] + (options[5] * options[4]) > video[VC_COLUMNS] then
        options[5] = floor((video[VC_COLUMNS] - options[2]) / options[4])
    end if

    -- Check if column length if OK
    if options[1] + options[3] > video[VC_LINES] then
        options[3] = video[VC_LINES] - options[1]
    end if

    -- Define variables
    if integer (length(items) / options[3]) then
        number_of_columns = length(items) / options[3]
    else
        number_of_columns = floor(length(items) / options[3]) + 1
    end if

    first_column = 1
    last_column = options[5]

    if last_column > number_of_columns then
        last_column = number_of_columns
        options[5] = number_of_columns
    end if

    -- Display scrollbar
    if options[7] then
        text_color(colors[1])
        bk_color(colors[2])
        

-------------- mo!!!!
  --      position((options[1]+options[3]),options[2])
    --    puts(1,196&repeat(196, (options[4]*options[5])-2)&196)
-------------- ya t.        

        position((options[1] + options[3]), options[2])
        puts(1, 17 & repeat(177, (options[4] * options[5]) - 2) & 16)
    end if

    reimprimir = 1
    current_column = first_column
    current_row = 1

    -- Main loop
    while 1 do
        if clock = 1 then
            dia_hora(clock_options, Date_options)
        end if
        if first_column < 1 then
                    if clock = 1 then
                                dia_hora(clock_options, Date_options)
                    end if
            first_column = 1
            reimprimir = 0
        end if

        last_column = first_column + options[5] - 1

        if last_column > number_of_columns then
            last_column = number_of_columns
            first_column = last_column - options[5] + 1
            reimprimir = 0
        end if

        if current_column < first_column then
            current_column = first_column
        elsif current_column > last_column then
            current_column = last_column
        end if

        if (options[3] * (current_column - 1) + current_row) >
          length(items) then
            current_row = length(items) -
              (options[3] * (current_column - 1))
        end if

        -- Display visible columns
        if reimprimir = 1 then
            reimprimir = 0
            aux1 = 0
            aux2 = 0
            text_color(colors[1])
            bk_color(colors[2])
            for loop = (options[3] * (first_column - 1) + 1) to
              (options[3] * (last_column - 1) + options[3]) do
                position((options[1] + aux1), (options[2] +
                  (aux2 * options[4])))
                if loop > length(items) then
                    puts(1, repeat(32, options[4]))
                else
                    puts(1, items[loop]
                      & repeat(32, options[4] - length(items[loop])))
                end if
                aux1 = aux1 + 1
                if aux1 = options[3] then
                    aux1 = 0
                    aux2 = aux2 + 1
                end if
            end for
        end if

        -- Display light-bar
        text_color(colors[3])
        bk_color(colors[4])
        position((options[1] + (current_row - 1)),
          (options[2] + ((current_column - first_column)
            * options[4])))
        if options[6] then
            puts(1, items[options[3] * (current_column - 1) + current_row] &
              repeat(32, options[4] - length(items[options[3] *
              (current_column - 1) + current_row])))
        else 
            puts(1, items[options[3] * (current_column - 1) + current_row])
        end if

        -- Update scrollbar (display cursor)
        if options[7] then
            aux2= floor(( options[5] * options[4]) / ( number_of_columns - 1))
              * ( current_column - 1) + 1
            if aux2 > (options[5] * options[4]) - 2 then
                aux2 = (options[5] * options[4]) - 2
            end if
            text_color(colors[1])
            bk_color(colors[2])
            position((options[1] + options[3]), (options[2] + aux2))
            puts(1,"")
        end if     
        while 1 do
           if clock = 1 then
                 dia_hora(clock_options, Date_options)
           end if 
           aux1 = get_key()
           if aux1 != -1 then
                exit
           end  if
        end while    
        text_color(colors[1])
        bk_color(colors[2])
        position((options[1] + (current_row - 1)),
          (options[2] + ((current_column - first_column)
            * options[4])))
        puts(1, items[options[3] * (current_column - 1) + current_row] &
          repeat(32, options[4] - length(items[options[3] *
          (current_column - 1) + current_row])))

        -- Update scrollbar (hide cursor)
        if options[7] then
            aux2= floor(( options[5] * options[4]) / ( number_of_columns - 1))
              * ( current_column - 1) + 1
            if aux2 > (options[5] * options[4]) - 2 then
                aux2 = (options[5] * options[4]) - 2
            end if
            position((options[1] + options[3]), (options[2] + aux2))
            puts(1, "")
        end if

        -- Check which key was pressed
        if aux1 = 13 then
            -- ENTER --> returns selected item's position
            return (options[3] * (current_column - 1) + current_row)
        elsif aux1 = 27 or aux1 = 9 then
            -- ESC --> returns -1, selection canceled
            return -1
        elsif aux1 = 328 then
            -- Up arrow
            if current_row - 1 >= 1 then
                current_row = current_row - 1
            elsif current_row - 1 < 1 then
                if current_column - 1 < first_column then
                    first_column = first_column - 1
                    reimprimir = 1
                end if
                if current_column > 1 then
                    current_row = options[3]
                    current_column = current_column - 1
                end if
            end if
        elsif aux1 = 336 then
            -- Down arrow
            if current_row + 1 <= options[3] then
                current_row = current_row + 1
            elsif current_row + 1 > options[3] then
                if current_column + 1 > last_column then
                    first_column = first_column + 1
                    reimprimir = 1
                end if
                if current_column < number_of_columns then
                    current_row = 1
                    current_column = current_column + 1
                end if
            end if
        elsif aux1 = 331 then
            -- Left arrow
            if current_column - 1 >= first_column then
                current_column = current_column - 1
            elsif current_column - 1 < first_column then
                    current_column = current_column - 1
                    first_column = first_column - 1
                    reimprimir = 1
            end if
        elsif aux1 = 333 then
            -- Right arrow
            if current_column + 1 <= last_column then
                current_column = current_column + 1
            elsif current_column + 1 > last_column then
                current_column = current_column + 1
                first_column = first_column + 1
                reimprimir = 1
            end if
        end if
   end while
end function

